require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ALPHA_COMPILER_H)) {
    eval 'sub __ALPHA_COMPILER_H () {1;}' unless defined(&__ALPHA_COMPILER_H);
    if((defined(&__GNUC__) ? &__GNUC__ : 0) == 3 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 4|| (defined(&__GNUC__) ? &__GNUC__ : 0) > 3) {
	eval 'sub __kernel_insbl {
	    my($val, $shift) = @_;
    	    eval q( &__builtin_alpha_insbl($val, $shift));
	}' unless defined(&__kernel_insbl);
	eval 'sub __kernel_inswl {
	    my($val, $shift) = @_;
    	    eval q( &__builtin_alpha_inswl($val, $shift));
	}' unless defined(&__kernel_inswl);
	eval 'sub __kernel_insql {
	    my($val, $shift) = @_;
    	    eval q( &__builtin_alpha_insql($val, $shift));
	}' unless defined(&__kernel_insql);
	eval 'sub __kernel_inslh {
	    my($val, $shift) = @_;
    	    eval q( &__builtin_alpha_inslh($val, $shift));
	}' unless defined(&__kernel_inslh);
	eval 'sub __kernel_extbl {
	    my($val, $shift) = @_;
    	    eval q( &__builtin_alpha_extbl($val, $shift));
	}' unless defined(&__kernel_extbl);
	eval 'sub __kernel_extwl {
	    my($val, $shift) = @_;
    	    eval q( &__builtin_alpha_extwl($val, $shift));
	}' unless defined(&__kernel_extwl);
	eval 'sub __kernel_cmpbge {
	    my($a, $b) = @_;
    	    eval q( &__builtin_alpha_cmpbge($a, $b));
	}' unless defined(&__kernel_cmpbge);
	eval 'sub __kernel_cttz {
	    my($x) = @_;
    	    eval q( &__builtin_ctzl($x));
	}' unless defined(&__kernel_cttz);
	eval 'sub __kernel_ctlz {
	    my($x) = @_;
    	    eval q( &__builtin_clzl($x));
	}' unless defined(&__kernel_ctlz);
	eval 'sub __kernel_ctpop {
	    my($x) = @_;
    	    eval q( &__builtin_popcountl($x));
	}' unless defined(&__kernel_ctpop);
    } else {
	eval 'sub __kernel_insbl {
	    my($val, $shift) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_insbl);
	eval 'sub __kernel_inswl {
	    my($val, $shift) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_inswl);
	eval 'sub __kernel_insql {
	    my($val, $shift) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_insql);
	eval 'sub __kernel_inslh {
	    my($val, $shift) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_inslh);
	eval 'sub __kernel_extbl {
	    my($val, $shift) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_extbl);
	eval 'sub __kernel_extwl {
	    my($val, $shift) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_extwl);
	eval 'sub __kernel_cmpbge {
	    my($a, $b) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_cmpbge);
	eval 'sub __kernel_cttz {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_cttz);
	eval 'sub __kernel_ctlz {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_ctlz);
	eval 'sub __kernel_ctpop {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_ctpop);
    }
    if(defined( &__alpha_bwx__)) {
	eval 'sub __kernel_ldbu {
	    my($mem) = @_;
    	    eval q(($mem));
	}' unless defined(&__kernel_ldbu);
	eval 'sub __kernel_ldwu {
	    my($mem) = @_;
    	    eval q(($mem));
	}' unless defined(&__kernel_ldwu);
	eval 'sub __kernel_stb {
	    my($val,$mem) = @_;
    	    eval q((($mem) = ($val)));
	}' unless defined(&__kernel_stb);
	eval 'sub __kernel_stw {
	    my($val,$mem) = @_;
    	    eval q((($mem) = ($val)));
	}' unless defined(&__kernel_stw);
    } else {
	eval 'sub __kernel_ldbu {
	    my($mem) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_ldbu);
	eval 'sub __kernel_ldwu {
	    my($mem) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_ldwu);
	eval 'sub __kernel_stb {
	    my($val,$mem) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_stb);
	eval 'sub __kernel_stw {
	    my($val,$mem) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__kernel_stw);
    }
    if(defined(&__KERNEL__)) {
	require 'linux/compiler.ph';
	undef(&inline) if defined(&inline);
	undef(&__inline__) if defined(&__inline__);
	undef(&__inline) if defined(&__inline);
    }
    if(defined(&__always_inline)) {
	undef(&__always_inline) if defined(&__always_inline);
    }
    eval 'sub __always_inline () { &inline  &__attribute__(( &always_inline));}' unless defined(&__always_inline);
}
1;
