require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ALPHA_PAGE_H)) {
    eval 'sub _ALPHA_PAGE_H () {1;}' unless defined(&_ALPHA_PAGE_H);
    if(defined(&__KERNEL__)) {
	require 'asm/pal.ph';
	eval 'sub PAGE_SHIFT () {13;}' unless defined(&PAGE_SHIFT);
	eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
	eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub STRICT_MM_TYPECHECKS () {1;}' unless defined(&STRICT_MM_TYPECHECKS);
	    eval 'sub clear_user_page {
	        my($page, $vaddr, $pg) = @_;
    		eval q( &clear_page($page));
	    }' unless defined(&clear_user_page);
	    eval 'sub alloc_zeroed_user_highpage {
	        my($vma, $vaddr) = @_;
    		eval q( &alloc_page_vma( &GFP_HIGHUSER |  &__GFP_ZERO, $vma,  &vmaddr));
	    }' unless defined(&alloc_zeroed_user_highpage);
	    eval 'sub __HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE () {1;}' unless defined(&__HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE);
	    eval 'sub copy_user_page {
	        my($to, $from, $vaddr, $pg) = @_;
    		eval q( &copy_page($to, $from));
	    }' unless defined(&copy_user_page);
	    if(defined(&STRICT_MM_TYPECHECKS)) {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q((($x). &pgd));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    my($x) = @_;
    		    eval q((($x). &pgprot));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q((( &pte_t) { ($x) } ));
		}' unless defined(&__pte);
		eval 'sub __pmd {
		    my($x) = @_;
    		    eval q((( &pmd_t) { ($x) } ));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q((( &pgd_t) { ($x) } ));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    my($x) = @_;
    		    eval q((( &pgprot_t) { ($x) } ));
		}' unless defined(&__pgprot);
	    } else {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pte);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgprot);
	    }
	    if(defined(&USE_48_BIT_KSEG)) {
		eval 'sub PAGE_OFFSET () {0xffff800000000000;}' unless defined(&PAGE_OFFSET);
	    } else {
		eval 'sub PAGE_OFFSET () {0xfffffc0000000000;}' unless defined(&PAGE_OFFSET);
	    }
	} else {
	    if(defined(&USE_48_BIT_KSEG)) {
		eval 'sub PAGE_OFFSET () {0xffff800000000000;}' unless defined(&PAGE_OFFSET);
	    } else {
		eval 'sub PAGE_OFFSET () {0xfffffc0000000000;}' unless defined(&PAGE_OFFSET);
	    }
	}
	eval 'sub PAGE_ALIGN {
	    my($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub __pa {
	    my($x) = @_;
    	    eval q(( ($x) -  &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    my($x) = @_;
    	    eval q((( &void *)( ($x) +  &PAGE_OFFSET)));
	}' unless defined(&__va);
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	    eval 'sub virt_to_page {
	        my($kaddr) = @_;
    		eval q( &pfn_to_page( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_to_page);
	    eval 'sub pfn_valid {
	        my($pfn) = @_;
    		eval q((($pfn) <  &max_mapnr));
	    }' unless defined(&pfn_valid);
	    eval 'sub virt_addr_valid {
	        my($kaddr) = @_;
    		eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_addr_valid);
	}
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
	require 'asm-generic/memory_model.ph';
	require 'asm-generic/page.ph';
    }
}
1;
