require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ALPHA_RWSEM_H)) {
    eval 'sub _ALPHA_RWSEM_H () {1;}' unless defined(&_ALPHA_RWSEM_H);
    unless(defined(&_LINUX_RWSEM_H)) {
	die("please don't include asm/rwsem.h directly, use linux/rwsem.h instead");
    }
    if(defined(&__KERNEL__)) {
	require 'linux/compiler.ph';
	require 'linux/list.ph';
	require 'linux/spinlock.ph';
	eval 'sub RWSEM_UNLOCKED_VALUE () {0x;}' unless defined(&RWSEM_UNLOCKED_VALUE);
	eval 'sub RWSEM_ACTIVE_BIAS () {0x1;}' unless defined(&RWSEM_ACTIVE_BIAS);
	eval 'sub RWSEM_ACTIVE_MASK () {0xffffffff;}' unless defined(&RWSEM_ACTIVE_MASK);
	eval 'sub RWSEM_WAITING_BIAS () {(-0x100000000);}' unless defined(&RWSEM_WAITING_BIAS);
	eval 'sub RWSEM_ACTIVE_READ_BIAS () { &RWSEM_ACTIVE_BIAS;}' unless defined(&RWSEM_ACTIVE_READ_BIAS);
	eval 'sub RWSEM_ACTIVE_WRITE_BIAS () {( &RWSEM_WAITING_BIAS +  &RWSEM_ACTIVE_BIAS);}' unless defined(&RWSEM_ACTIVE_WRITE_BIAS);
	eval 'sub __RWSEM_INITIALIZER {
	    my($name) = @_;
    	    eval q({  &RWSEM_UNLOCKED_VALUE,  &SPIN_LOCK_UNLOCKED,  &LIST_HEAD_INIT(($name). &wait_list) });
	}' unless defined(&__RWSEM_INITIALIZER);
	eval 'sub DECLARE_RWSEM {
	    my($name) = @_;
    	    eval q(1;
	}' unless defined(&DECLARE_RWSEM);
	eval 'sub init_rwsem {
	    my($sem) = @_;
    	    eval q({  ($sem->{count}) =  &RWSEM_UNLOCKED_VALUE;  &spin_lock_init( ($sem->{wait_lock}));  &INIT_LIST_HEAD( ($sem->{wait_list})); });
	}' unless defined(&init_rwsem);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __down_read {
	    my($sem) = @_;
    	    eval q({ my $oldcount;  &if ( &unlikely( $oldcount < 0))  &rwsem_down_read_failed($sem); });
	}' unless defined(&__down_read);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __down_write {
	    my($sem) = @_;
    	    eval q({ my $oldcount;  &if ( &unlikely( $oldcount))  &rwsem_down_write_failed($sem); });
	}' unless defined(&__down_write);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __up_read {
	    my($sem) = @_;
    	    eval q({ my $oldcount;  &if ( &unlikely( $oldcount < 0))  &if ( $oldcount -  &RWSEM_ACTIVE_READ_BIAS == 0)  &rwsem_wake($sem); });
	}' unless defined(&__up_read);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __up_write {
	    my($sem) = @_;
    	    eval q({ my $count;  &if ( &unlikely)  &if ( $count == 0)  &rwsem_wake($sem); });
	}' unless defined(&__up_write);
	unless(defined(&CONFIG_SMP)) {
	} else {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub rwsem_atomic_add {
	    my($val,$sem) = @_;
    	    eval q({ });
	}' unless defined(&rwsem_atomic_add);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub rwsem_atomic_update {
	    my($val,$sem) = @_;
    	    eval q({ });
	}' unless defined(&rwsem_atomic_update);
	eval 'sub rwsem_is_locked {
	    my($sem) = @_;
    	    eval q({ ( ($sem->{count}) != 0); });
	}' unless defined(&rwsem_is_locked);
    }
}
1;
