require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ALPHA_SYSTEM_H)) {
    eval 'sub __ALPHA_SYSTEM_H () {1;}' unless defined(&__ALPHA_SYSTEM_H);
    require 'asm/pal.ph';
    require 'asm/page.ph';
    require 'asm/barrier.ph';
    eval 'sub BOOT_PCB () {0x20000000;}' unless defined(&BOOT_PCB);
    eval 'sub BOOT_ADDR () {0x20000000;}' unless defined(&BOOT_ADDR);
    eval 'sub BOOT_SIZE () {(16*1024);}' unless defined(&BOOT_SIZE);
    if(defined(&CONFIG_ALPHA_LEGACY_START_ADDRESS)) {
	eval 'sub KERNEL_START_PHYS () {0x300000;}' unless defined(&KERNEL_START_PHYS);
    } else {
	eval 'sub KERNEL_START_PHYS () {0x1000000;}' unless defined(&KERNEL_START_PHYS);
    }
    eval 'sub KERNEL_START () {( &PAGE_OFFSET+ &KERNEL_START_PHYS);}' unless defined(&KERNEL_START);
    eval 'sub SWAPPER_PGD () { &KERNEL_START;}' unless defined(&SWAPPER_PGD);
    eval 'sub INIT_STACK () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x2000);}' unless defined(&INIT_STACK);
    eval 'sub EMPTY_PGT () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x4000);}' unless defined(&EMPTY_PGT);
    eval 'sub EMPTY_PGE () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x8000);}' unless defined(&EMPTY_PGE);
    eval 'sub ZERO_PGE () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0xa000);}' unless defined(&ZERO_PGE);
    eval 'sub START_ADDR () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x10000);}' unless defined(&START_ADDR);
    eval 'sub PARAM () { &ZERO_PGE;}' unless defined(&PARAM);
    eval 'sub COMMAND_LINE () {(( &PARAM + 0x));}' unless defined(&COMMAND_LINE);
    eval 'sub INITRD_START () {(* ( &PARAM+0x100));}' unless defined(&INITRD_START);
    eval 'sub INITRD_SIZE () {(* ( &PARAM+0x108));}' unless defined(&INITRD_SIZE);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/kernel.ph';
	eval 'sub __halt () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&__halt);
	eval 'sub switch_to {
	    my($P,$N,$L) = @_;
    	    eval q( &do { ($L) =  &alpha_switch_to( &virt_to_phys( &task_thread_info($N)-> &pcb), ($P));  &check_mmu_context(); }  &while (0));
	}' unless defined(&switch_to);
	eval 'sub imb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&imb);
	eval 'sub draina () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&draina);
	eval("sub IMPLVER_EV4 () { 0; }") unless defined(&IMPLVER_EV4);
	eval("sub IMPLVER_EV5 () { 1; }") unless defined(&IMPLVER_EV5);
	eval("sub IMPLVER_EV6 () { 2; }") unless defined(&IMPLVER_EV6);
	if(defined(&CONFIG_ALPHA_GENERIC)) {
	    eval 'sub implver () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&implver);
	} else {
	    if(defined(&CONFIG_ALPHA_EV4)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV4);
		}' unless defined(&implver);
	    }
	    if(defined(&CONFIG_ALPHA_EV5)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV5);
		}' unless defined(&implver);
	    }
	    if(defined( &CONFIG_ALPHA_EV6)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV6);
		}' unless defined(&implver);
	    }
	}
	eval("sub AMASK_BWX () { (1UL<<0); }") unless defined(&AMASK_BWX);
	eval("sub AMASK_FIX () { (1UL<<1); }") unless defined(&AMASK_FIX);
	eval("sub AMASK_CIX () { (1UL<<2); }") unless defined(&AMASK_CIX);
	eval("sub AMASK_MAX () { (1UL<<8); }") unless defined(&AMASK_MAX);
	eval("sub AMASK_PRECISE_TRAP () { (1UL<<9); }") unless defined(&AMASK_PRECISE_TRAP);
	eval 'sub amask {
	    my($mask) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&amask);
	eval 'sub __CALL_PAL_R0 {
	    my($NAME, $TYPE) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_R0);
	eval 'sub __CALL_PAL_W1 {
	    my($NAME, $TYPE0) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_W1);
	eval 'sub __CALL_PAL_W2 {
	    my($NAME, $TYPE0, $TYPE1) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_W2);
	eval 'sub __CALL_PAL_RW1 {
	    my($NAME, $RTYPE, $TYPE0) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_RW1);
	eval 'sub __CALL_PAL_RW2 {
	    my($NAME, $RTYPE, $TYPE0, $TYPE1) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_RW2);
	eval 'sub IPL_MIN () {0;}' unless defined(&IPL_MIN);
	eval 'sub IPL_SW0 () {1;}' unless defined(&IPL_SW0);
	eval 'sub IPL_SW1 () {2;}' unless defined(&IPL_SW1);
	eval 'sub IPL_DEV0 () {3;}' unless defined(&IPL_DEV0);
	eval 'sub IPL_DEV1 () {4;}' unless defined(&IPL_DEV1);
	eval 'sub IPL_TIMER () {5;}' unless defined(&IPL_TIMER);
	eval 'sub IPL_PERF () {6;}' unless defined(&IPL_PERF);
	eval 'sub IPL_POWERFAIL () {6;}' unless defined(&IPL_POWERFAIL);
	eval 'sub IPL_MCHECK () {7;}' unless defined(&IPL_MCHECK);
	eval 'sub IPL_MAX () {7;}' unless defined(&IPL_MAX);
	if(defined(&CONFIG_ALPHA_BROKEN_IRQ_MASK)) {
	    undef(&IPL_MIN) if defined(&IPL_MIN);
	    eval 'sub IPL_MIN () { &__min_ipl;}' unless defined(&IPL_MIN);
	}
	eval 'sub getipl () {
	    eval q(( &rdps() & 7));
	}' unless defined(&getipl);
	eval 'sub setipl {
	    my($ipl) = @_;
    	    eval q((( &void)  &swpipl($ipl)));
	}' unless defined(&setipl);
	eval 'sub local_irq_disable () {
	    eval q( &do {  &setipl( &IPL_MAX);  &barrier(); }  &while(0));
	}' unless defined(&local_irq_disable);
	eval 'sub local_irq_enable () {
	    eval q( &do {  &barrier();  &setipl( &IPL_MIN); }  &while(0));
	}' unless defined(&local_irq_enable);
	eval 'sub local_save_flags {
	    my($flags) = @_;
    	    eval q((($flags) =  &rdps()));
	}' unless defined(&local_save_flags);
	eval 'sub local_irq_save {
	    my($flags) = @_;
    	    eval q( &do { ($flags) =  &swpipl( &IPL_MAX);  &barrier(); }  &while(0));
	}' unless defined(&local_irq_save);
	eval 'sub local_irq_restore {
	    my($flags) = @_;
    	    eval q( &do {  &barrier();  &setipl($flags);  &barrier(); }  &while(0));
	}' unless defined(&local_irq_restore);
	eval 'sub irqs_disabled () {
	    eval q(( &getipl() ==  &IPL_MAX));
	}' unless defined(&irqs_disabled);
	eval 'sub __tbi () {"(assembly code)";}' unless defined(&__tbi);
	eval 'sub tbi {
	    my($x,$y) = @_;
    	    eval q( &__tbi($x, &__r17=($y),\\"1\\" ( &__r17)));
	}' unless defined(&tbi);
	eval 'sub tbisi {
	    my($x) = @_;
    	    eval q( &__tbi(1, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbisi);
	eval 'sub tbisd {
	    my($x) = @_;
    	    eval q( &__tbi(2, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbisd);
	eval 'sub tbis {
	    my($x) = @_;
    	    eval q( &__tbi(3, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbis);
	eval 'sub tbiap () {
	    eval q( &__tbi(-1, ));
	}' unless defined(&tbiap);
	eval 'sub tbia () {
	    eval q( &__tbi(-2, ));
	}' unless defined(&tbia);
	if(defined(&CONFIG_SMP)) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __xchg_u16 {
	    my($m,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__xchg_u16);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __xchg_u32 {
	    my($m,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__xchg_u32);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __xchg_u64 {
	    my($m,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__xchg_u64);
	eval 'sub __xchg {
	    my($ptr, $x, $size) = @_;
    	    eval q(({ \'unsigned long __xchg__res\';  &volatile  &void * &__xchg__ptr = ($ptr);  &switch ($size) {  &case 1:  &__xchg__res =  &__xchg_u8( &__xchg__ptr, $x);  &break;  &case 2:  &__xchg__res =  &__xchg_u16( &__xchg__ptr, $x);  &break;  &case 4:  &__xchg__res =  &__xchg_u32( &__xchg__ptr, $x);  &break;  &case 8:  &__xchg__res =  &__xchg_u64( &__xchg__ptr, $x);  &break;  &default:  &__xchg_called_with_bad_pointer();  &__xchg__res = $x; }  &__xchg__res; }));
	}' unless defined(&__xchg);
	eval 'sub xchg {
	    my($ptr,$x) = @_;
    	    eval q(({  &__typeof__(*($ptr))  &_x_ = ($x); ( &__typeof__(*($ptr)))  &__xchg(($ptr),  &_x_, $sizeof{($ptr)}); }));
	}' unless defined(&xchg);
	eval 'sub tas {
	    my($ptr) = @_;
    	    eval q(( &xchg(($ptr),1)));
	}' unless defined(&tas);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg_u8 {
	    my($m,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__cmpxchg_u8);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg_u16 {
	    my($m,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__cmpxchg_u16);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg_u32 {
	    my($m,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__cmpxchg_u32);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg_u64 {
	    my($m,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__cmpxchg_u64);
	eval 'sub cmpxchg {
	    my($ptr,$o,$n) = @_;
    	    eval q(({  &__typeof__(*($ptr))  &_o_ = ($o);  &__typeof__(*($ptr))  &_n_ = ($n); ( &__typeof__(*($ptr)))  &__cmpxchg(($ptr),  &_o_,  &_n_, $sizeof{($ptr)}); }));
	}' unless defined(&cmpxchg);
    }
    eval 'sub arch_align_stack {
        my($x) = @_;
	    eval q(($x));
    }' unless defined(&arch_align_stack);
}
1;
